"use strict";var state=require("@codemirror/state"),view=require("@codemirror/view"),language=require("@codemirror/language"),autocomplete=require("@codemirror/autocomplete"),markdown$1=require("@lezer/markdown"),langHtml=require("@codemirror/lang-html"),common=require("@lezer/common");const data=language.defineLanguageFacet({commentTokens:{block:{open:"\x3c!--",close:"--\x3e"}}}),headingProp=new common.NodeProp,commonmark=markdown$1.parser.configure({props:[language.foldNodeProp.add((e=>!e.is("Block")||e.is("Document")||null!=isHeading(e)?void 0:(e,t)=>({from:t.doc.lineAt(e.from).to,to:e.to}))),headingProp.add(isHeading),language.indentNodeProp.add({Document:()=>null}),language.languageDataProp.add({Document:data})]});function isHeading(e){let t=/^(?:ATX|Setext)Heading(\d)$/.exec(e.name);return t?+t[1]:void 0}function findSectionEnd(e,t){let n=e;for(;;){let e,r=n.nextSibling;if(!r||null!=(e=isHeading(r.type))&&e<=t)break;n=r}return n.to}const headerIndent=language.foldService.of(((e,t,n)=>{for(let r=language.syntaxTree(e).resolveInner(n,-1);r&&!(r.from<t);r=r.parent){let e=r.type.prop(headingProp);if(null==e)continue;let t=findSectionEnd(r,e);if(t>n)return{from:n,to:t}}return null}));function mkLang(e){return new language.Language(data,e,[headerIndent],"markdown")}const commonmarkLanguage=mkLang(commonmark),extended=commonmark.configure([markdown$1.GFM,markdown$1.Subscript,markdown$1.Superscript,markdown$1.Emoji,{props:[language.foldNodeProp.add({Table:(e,t)=>({from:t.doc.lineAt(e.from).to,to:e.to})})]}]),markdownLanguage=mkLang(extended);function getCodeParser(e,t){return n=>{if(n&&e){let t=null;if(n=/\S*/.exec(n)[0],t="function"==typeof e?e(n):language.LanguageDescription.matchLanguageName(e,n,!0),t instanceof language.LanguageDescription)return t.support?t.support.language.parser:language.ParseContext.getSkippingParser(t.load());if(t)return t.parser}return t?t.parser:null}}class Context{constructor(e,t,n,r,o,a,l){this.node=e,this.from=t,this.to=n,this.spaceBefore=r,this.spaceAfter=o,this.type=a,this.item=l}blank(e,t=!0){let n=this.spaceBefore+("Blockquote"==this.node.name?">":"");if(null!=e){for(;n.length<e;)n+=" ";return n}for(let r=this.to-this.from-n.length-this.spaceAfter.length;r>0;r--)n+=" ";return n+(t?this.spaceAfter:"")}marker(e,t){let n="OrderedList"==this.node.name?String(+itemNumber(this.item,e)[2]+t):"";return this.spaceBefore+n+this.type+this.spaceAfter}}function getContext(e,t){let n=[];for(let o=e;o&&"Document"!=o.name;o=o.parent)"ListItem"!=o.name&&"Blockquote"!=o.name&&"FencedCode"!=o.name||n.push(o);let r=[];for(let o=n.length-1;o>=0;o--){let e,a=n[o],l=t.lineAt(a.from),i=a.from-l.from;if("FencedCode"==a.name)r.push(new Context(a,i,i,"","","",null));else if("Blockquote"==a.name&&(e=/^ *>( ?)/.exec(l.text.slice(i))))r.push(new Context(a,i,i+e[0].length,"",e[1],">",null));else if("ListItem"==a.name&&"OrderedList"==a.parent.name&&(e=/^( *)\d+([.)])( *)/.exec(l.text.slice(i)))){let t=e[3],n=e[0].length;t.length>=4&&(t=t.slice(0,t.length-4),n-=4),r.push(new Context(a.parent,i,i+n,e[1],t,e[2],a))}else if("ListItem"==a.name&&"BulletList"==a.parent.name&&(e=/^( *)([-+*])( {1,4}\[[ xX]\])?( +)/.exec(l.text.slice(i)))){let t=e[4],n=e[0].length;t.length>4&&(t=t.slice(0,t.length-4),n-=4);let o=e[2];e[3]&&(o+=e[3].replace(/[xX]/," ")),r.push(new Context(a.parent,i,i+n,e[1],t,o,a))}}return r}function itemNumber(e,t){return/^(\s*)(\d+)(?=[.)])/.exec(t.sliceString(e.from,e.from+10))}function renumberList(e,t,n,r=0){for(let o=-1,a=e;;){if("ListItem"==a.name){let e=itemNumber(a,t),l=+e[2];if(o>=0){if(l!=o+1)return;n.push({from:a.from+e[1].length,to:a.from+e[0].length,insert:String(o+2+r)})}o=l}let e=a.nextSibling;if(!e)break;a=e}}function normalizeIndent(e,t){let n=/^[ \t]*/.exec(e)[0].length;if(!n||"\t"!=t.facet(language.indentUnit))return e;let r="";for(let o=state.countColumn(e,4,n);o>0;)o>=4?(r+="\t",o-=4):(r+=" ",o--);return r+e.slice(n)}const insertNewlineContinueMarkup=({state:e,dispatch:t})=>{let n=language.syntaxTree(e),{doc:r}=e,o=null,a=e.changeByRange((t=>{if(!t.empty||!markdownLanguage.isActiveAt(e,t.from))return o={range:t};let a=t.from,l=r.lineAt(a),i=getContext(n.resolveInner(a,-1),r);for(;i.length&&i[i.length-1].from>a-l.from;)i.pop();if(!i.length)return o={range:t};let m=i[i.length-1];if(m.to-m.spaceAfter.length>a-l.from)return o={range:t};let s=a>=m.to-m.spaceAfter.length&&!/\S/.test(l.text.slice(m.to));if(m.item&&s){if(m.node.firstChild.to>=a||l.from>0&&!/[^\s>]/.test(r.lineAt(l.from-1).text)){let e,t=i.length>1?i[i.length-2]:null,n="";t&&t.item?(e=l.from+t.from,n=t.marker(r,1)):e=l.from+(t?t.to:0);let o=[{from:e,to:a,insert:n}];return"OrderedList"==m.node.name&&renumberList(m.item,r,o,-2),t&&"OrderedList"==t.node.name&&renumberList(t.item,r,o),{range:state.EditorSelection.cursor(e+n.length),changes:o}}{let t="";for(let e=0,n=i.length-2;e<=n;e++)t+=i[e].blank(e<n?state.countColumn(l.text,4,i[e+1].from)-t.length:null,e<n);return t=normalizeIndent(t,e),{range:state.EditorSelection.cursor(a+t.length+1),changes:{from:l.from,insert:t+e.lineBreak}}}}if("Blockquote"==m.node.name&&s&&l.from){let n=r.lineAt(l.from-1),o=/>\s*$/.exec(n.text);if(o&&o.index==m.from){let r=e.changes([{from:n.from+o.index,to:n.to},{from:l.from+m.from,to:l.to}]);return{range:t.map(r),changes:r}}}let u=[];"OrderedList"==m.node.name&&renumberList(m.item,r,u);let g=m.item&&m.item.from<l.from,c="";if(!g||/^[\s\d.)\-+*>]*/.exec(l.text)[0].length>=m.to)for(let e=0,n=i.length-1;e<=n;e++)c+=e!=n||g?i[e].blank(e<n?state.countColumn(l.text,4,i[e+1].from)-c.length:null):i[e].marker(r,1);let f=a;for(;f>l.from&&/\s/.test(l.text.charAt(f-l.from-1));)f--;return c=normalizeIndent(c,e),u.push({from:f,to:a,insert:e.lineBreak+c}),{range:state.EditorSelection.cursor(f+c.length+1),changes:u}}));return!o&&(t(e.update(a,{scrollIntoView:!0,userEvent:"input"})),!0)};function isMark(e){return"QuoteMark"==e.name||"ListMark"==e.name}function contextNodeForDelete(e,t){let n=e.resolveInner(t,-1),r=t;isMark(n)&&(r=n.from,n=n.parent);for(let o;o=n.childBefore(r);)if(isMark(o))r=o.from;else{if("OrderedList"!=o.name&&"BulletList"!=o.name)break;n=o.lastChild,r=n.to}return n}const deleteMarkupBackward=({state:e,dispatch:t})=>{let n=language.syntaxTree(e),r=null,o=e.changeByRange((t=>{let o=t.from,{doc:a}=e;if(t.empty&&markdownLanguage.isActiveAt(e,t.from)){let t=a.lineAt(o),r=getContext(contextNodeForDelete(n,o),a);if(r.length){let n=r[r.length-1],a=n.to-n.spaceAfter.length+(n.spaceAfter?1:0);if(o-t.from>a&&!/\S/.test(t.text.slice(a,o-t.from)))return{range:state.EditorSelection.cursor(t.from+a),changes:{from:t.from+a,to:o}};if(o-t.from==a&&(!n.item||t.from<=n.item.from||!/\S/.test(t.text.slice(0,n.to)))){let r=t.from+n.from;if(n.item&&n.node.from<n.item.from&&/\S/.test(t.text.slice(n.from,n.to))){let o=n.blank(state.countColumn(t.text,4,n.to)-state.countColumn(t.text,4,n.from));return r==t.from&&(o=normalizeIndent(o,e)),{range:state.EditorSelection.cursor(r+o.length),changes:{from:r,to:t.from+n.to,insert:o}}}if(r<o)return{range:state.EditorSelection.cursor(r),changes:{from:r,to:o}}}}}return r={range:t}}));return!r&&(t(e.update(o,{scrollIntoView:!0,userEvent:"delete"})),!0)},markdownKeymap=[{key:"Enter",run:insertNewlineContinueMarkup},{key:"Backspace",run:deleteMarkupBackward}],htmlNoMatch=langHtml.html({matchClosingTags:!1});function markdown(e={}){let{codeLanguages:t,defaultCodeLanguage:n,addKeymap:r=!0,base:{parser:o}=commonmarkLanguage,completeHTMLTags:a=!0}=e;if(!(o instanceof markdown$1.MarkdownParser))throw new RangeError("Base parser provided to `markdown` should be a Markdown parser");let l,i=e.extensions?[e.extensions]:[],m=[htmlNoMatch.support];n instanceof language.LanguageSupport?(m.push(n.support),l=n.language):n&&(l=n);let s=t||l?getCodeParser(t,l):void 0;i.push(markdown$1.parseCode({codeParser:s,htmlParser:htmlNoMatch.language.parser})),r&&m.push(state.Prec.high(view.keymap.of(markdownKeymap)));let u=mkLang(o.configure(i));return a&&m.push(u.data.of({autocomplete:htmlTagCompletion})),new language.LanguageSupport(u,m)}function htmlTagCompletion(e){let{state:t,pos:n}=e,r=/<[:\-\.\w\u00b7-\uffff]*$/.exec(t.sliceDoc(n-25,n));if(!r)return null;let o=language.syntaxTree(t).resolveInner(n,-1);for(;o&&!o.type.isTop;){if("CodeBlock"==o.name||"FencedCode"==o.name||"ProcessingInstructionBlock"==o.name||"CommentBlock"==o.name||"Link"==o.name||"Image"==o.name)return null;o=o.parent}return{from:n-r[0].length,to:n,options:htmlTagCompletions(),validFor:/^<[:\-\.\w\u00b7-\uffff]*$/}}let _tagCompletions=null;function htmlTagCompletions(){if(_tagCompletions)return _tagCompletions;let e=langHtml.htmlCompletionSource(new autocomplete.CompletionContext(state.EditorState.create({extensions:htmlNoMatch}),0,!0));return _tagCompletions=e?e.options:[]}exports.commonmarkLanguage=commonmarkLanguage,exports.deleteMarkupBackward=deleteMarkupBackward,exports.insertNewlineContinueMarkup=insertNewlineContinueMarkup,exports.markdown=markdown,exports.markdownKeymap=markdownKeymap,exports.markdownLanguage=markdownLanguage;